<?

 /*************************************************************************************
 * Filename: modules/categories.php
 *
 * This file is part of the Forum JAS plugin.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The Forum JAS plugin is free software under the terms of the
 * GNU General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the plugin or http://jas.junerules.com/plugins/forum/
 *************************************************************************************/


 require_once($_path["include"]."module.php");

 class Plugin_Module_forum_categories extends Module
 {
  function __construct(&$data)
  {
   global $_path;

   parent::__construct($data);

   if($this->data->module!="categories")
    $this->extend("categories");

   $this->data->title="Forum categories";

//   $this->data->addField("explanation", "text", "all", false, 0, 2500, false, "Explanation", "Explanation about it's content");

   //hide text+ordernr fields
//   $this->data->field["text"]["use"]="sql"; 
   $this->data->field["ordernr"]["use"]="sql"; 

   //fake forums/threads fields
   $this->data->addField("forums", "nr", "show", false, false, false, 0, "Sub forums");
   $this->data->addField("threads", "nr", "show", false, false, false, 0, "Threads");
   $this->data->addField("posts", "nr", "show", false, false, false, 0, "Posts");

   $this->data->addField("lastpost", "nr", "show", false, false, false, false, "Last post");
   $this->data->addReference("lastpost", "forum_threads", "nr", "*:0");

   //set forum modules
   $this->data->field["module"]["value"][0]=Array("forum_categories", "forum_threads");

   $this->data->group("Forum", "forums", "threads", "posts", "lastpost");
   $this->data->group("Module", "moduleLock", "module");
   $this->data->group("Other", "catnr", "owner", "updated", "treedepth");
  }

  function deletePostSubmitErrorCheck()
  {
   if(!$this->data->extends["categories"]->moduleObject->deletePostSubmitErrorCheck())
   {
    $this->data->e->add($this->data->extends["categories"]->e);
    return false;
   }

   return true;
  }

  function movePostGet(){return $this->viewPostGet();}
  function deletePostGet(){return $this->viewPostGet();}

  function viewPostGet()
  {
   //get total sub forums per forum
   if($this->data->check("use", "show", "forums"))
   {
    $d=Data::cache($this->data->module, "view", "list");
    $d->setShowFields();
    $d->clearValues();

    for($c=0;$c<$this->data->vmax;$c++)
    {
     $d->setValue("catnr", $this->data->getValue("nr", $c));

     if(!$d->get(false, true)) //get count
     {
      $this->data->e->add($d->e);
      return false;
     }

     $this->data->setValue("forums", $d->getValue("show_count"), $c);
    }
   }

   //get total threads per forum
   if($this->data->check("use", "show", "threads"))
   {
    $d=Data::cache("forum_threads", "view", "all");
    $d->setShowFields();
    $d->clearValues();

    for($c=0;$c<$this->data->vmax;$c++)
    {
     $d->setValue("threadnr", 0);
     $d->setValue("catnr", $this->data->getValue("nr", $c));

     if(!$d->get(false, true)) //get count
     {
      $this->data->e->add($d->e);
      return false;
     }

     $this->data->setValue("threads", $d->getValue("show_count"), $c);
    }
   }

   //get total posts per forum
   if($this->data->check("use", "show", "posts"))
   {
    $d=Data::cache("forum_threads", "view", "all");
    $d->setShowFields();
    $d->clearValues();

    for($c=0;$c<$this->data->vmax;$c++)
    {
     $d->setValue("catnr", $this->data->getValue("nr", $c));

     if(!$d->get(false, true)) //get count
     {
      $this->data->e->add($d->e);
      return false;
     }

     $this->data->setValue("posts", $d->getValue("show_count"), $c);
    }
   }

   //get last post time and subject
   if($this->data->check("use", "show", "lastpost"))
   {
    $d=Data::cache("forum_threads", "view", "all");
    $d->setShowFields("nr");
    $d->clearValues();
    $d->sortOrder("updated-");

    for($c=0;$c<$this->data->vmax;$c++)
    {
     $d->setValue("show_total", 1);
     $d->setValue("catnr", $this->data->getValue("nr", $c));

     if(!$d->get()) 
     {
      $this->data->e->add($d->e);
      return false;
     }

     $this->data->setValue("lastpost", $d->getValue("nr"), $c);
    }
   }

   return true;
  }

 }
?>
