<?

 /*************************************************************************************
 * Filename: modules/pluginInfo.php
 *
 * This file is part of the Forum JAS plugin.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The Forum JAS plugin is free software under the terms of the
 * GNU General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the plugin or http://jas.junerules.com/plugins/forum/
 *************************************************************************************/


 require_once($_path["include"]."module.php");

 class Plugin_Module_forum_pluginInfo extends Module
 {
  function __construct(&$data)
  {
   parent::__construct($data);

   if($this->data->module!="pluginInfo")
    $this->extend("pluginInfo");

   $this->data->title="Forum plugin information";

   $this->data->addField("templateitem", "localfile", "all", false, 1, 255, "item.html", "Thread template");
   $this->data->addField("templatelist", "localfile", "all", false, 1, 255, "list.html", "Threads template");
   $this->data->addField("templatecategories", "localfile", "all", false, 1, 255, "categories.html", "Categories template");
   $this->data->addField("templatetree", "localfile", "all", false, 1, 255, "tree.html", "Thread template");
  }

  function postInit()
  {
   global $_path;

   $this->data->setFileDir("templateitem", $_path["project"]["plugins"]."forum/templates/");
   $this->data->setFileExtensions("templateitem", "html", "htm");

   $this->data->setFileDir("templatelist", $_path["project"]["plugins"]."forum/templates/");
   $this->data->setFileExtensions("templatelist", "html", "htm");

   $this->data->setFileDir("templatecategories", $_path["project"]["plugins"]."forum/templates/");
   $this->data->setFileExtensions("templatecategories", "html", "htm");

   $this->data->setFileDir("templatetree", $_path["project"]["plugins"]."forum/templates/");
   $this->data->setFileExtensions("templatetree", "html", "htm");

   return true;
  }
 }
?>
